library aursir_polymer.import;

import 'package:polymer/polymer.dart';
import 'dart:convert';
import 'package:aursir4dart/imported_appkey.dart';
import 'package:aursir4dart/aursir_interface.dart';

@CustomTag('aursir-polymer-import')
class AursirImportElement extends PolymerElement {
    @published AurSirImport asimport;
    @published bool exported;
    @published var onexported;

    @published String appkey;
    @published List<String> tags = [];

    @observable AurSirInterface interface;
    @observable bool docked;

    void CallFunction(String FunctionName, [Map Parameter]) => asimport.CallFunction(FunctionName,Parameter);

    AursirImportElement.created(): super.created();
    attached() {

        var parsedKey = JSON.decode(appkey);

        asimport = interface.Import(parsedKey,tags);
        asimport.setOnExported(setExported);

    }
    void setExported(bool d){
        this.exported = d;

        if (onexported!=null) {
            onexported(d);
        }
    }
}
