library aursir_polymer.listen;

import 'package:polymer/polymer.dart';
import 'dart:async';
import 'package:aursir4dart/imported_appkey.dart';

@CustomTag('aursir-polymer-listen')
class AursirListenElement extends PolymerElement {
    @observable AurSirImport asimport;
    @published bool exported;
    @published bool onexported;

    @published String appkey;
    @published List<String> tags = [];

    @published String function;
    @published List<String> functions;

    AursirListenElement.created(): super.created();
    attached() {
        activateListen();

    }
    void CallFunction(String FunctionName, [Map Parameter]) => $['import'].CallFunction(FunctionName,Parameter);

    void activateListen(){
        if (asimport != null) {
            asimport.setOnResult(onResult);
            if (function != null){
                asimport.ListenToFunction(function);
            } else {
                for (var fun in functions) {
                    asimport.ListenToFunction(fun);
                }
            }

        } else {
            new Timer(new Duration(milliseconds:100), () => activateListen());
        }


    }

    void onResult(function, result) {
        fire('update', detail:{"function":function,"result":result});
    }
}
